// license: AGPLv3 or later
// copyright 2023 zamfofex

#include <mimimi/chapter-I/dialogues.h>
#include <mimimi/compound-behaviors.h>
#include <mimimi/chapter-I/models.h>

#include <mimimi/chapter-I/story.h>

void mimimi_chapter_I_story(struct mimimi_behavior *behavior, struct mimimi_behavior *compound, void *data)
{
	struct mimimi_chapter_I_story *story_data = data;
	struct mimimi_chapter *chapter = story_data->chapter;
	struct mimimi_engine *engine = story_data->engine;
	struct mimimi_allocator *allocator = story_data->allocator;
	struct mimimi_sprite *player = story_data->player;
	
	struct mimimi_chapter_I_paragraph paragraphs[] =
	{
		{mimimi_chapter_I_mirai_flash, "Mirai", "There seems to be nothing for me to do. Hmmm... Maybe I can find something to do later."},
		{mimimi_chapter_I_ryouna_flash, "Ry\xC5\x8Dna", "Hear that? If you come back later, then maybe you can find something to do!"},
		{mimimi_chapter_I_ryoubi_flash, "Ry\xC5\x8Dbi", "Who are you talking with? Are you stupid or something?"},
		{mimimi_chapter_I_ryouna_flash, "Ry\xC5\x8Dna", "Aaah! Ry\xC5\x8Dbi, I really like when you yell insults at me!"},
		{mimimi_chapter_I_mirai_flash, "Mirai", "Wha-? What are you two doing here?"},
		{mimimi_chapter_I_haruka_flash, "Haruka", "Hehe, don't worry about it!"},
	};
	
	struct mimimi_chapter_I_dialogue dialogue = {sizeof paragraphs / sizeof *paragraphs - 1, paragraphs};
	
	while (player->position->x > 1024) (*behavior->behave)(behavior->data);
	
	mimimi_chapter_I_show_toast_dialogue_bottom(behavior, engine, chapter, &dialogue, allocator);
}
