// license: AGPLv3 or later
// copyright 2023 zamfofex

#ifndef MIMIMI_CHAPTER_I_APPEARANCES_H
#define MIMIMI_CHAPTER_I_APPEARANCES_H

struct mimimi_animation;
struct mimimi_video;
struct mimimi_model;
struct mimimi_allocator;
struct mimimi_engine;
struct mimimi_coroutine_provider;
struct mimimi_behavior;
struct mimimi_sprite;
struct mimimi_position;

struct mimimi_chapter_I_animation_set
{
	int standing_animation_count;
	int jumping_animation_count;
	struct mimimi_animation *standing;
	struct mimimi_animation *knocked;
	struct mimimi_animation *falling;
	struct mimimi_animation *jumping;
};

struct mimimi_chapter_I_appearance
{
	struct mimimi_chapter_I_animation_set left, right;
};

struct mimimi_chapter_I_video_set
{
	int standing_video_count;
	int jumping_video_count;
	struct mimimi_video *standing;
	struct mimimi_video *knocked;
	struct mimimi_video *falling;
	struct mimimi_video *jumping;
};

struct mimimi_chapter_I_video_appearance
{
	struct mimimi_chapter_I_video_set left, right;
};

struct mimimi_chapter_I_appearance *mimimi_chapter_I_appearance(struct mimimi_model *model, struct mimimi_allocator *allocator);
void mimimi_chapter_I_video_appearance(struct mimimi_chapter_I_video_appearance *video_appearance, struct mimimi_chapter_I_appearance *appearance, struct mimimi_engine *engine, struct mimimi_allocator *allocator);

void mimimi_chapter_I_display(struct mimimi_behavior *compound, struct mimimi_engine *engine, struct mimimi_position *camera, struct mimimi_sprite *sprite, struct mimimi_chapter_I_video_appearance *appearance, int x, int y, struct mimimi_allocator *allocator);

#endif
